wxWidgets: wxGridEvent Class Reference

| Version: 3.1.5

Loading...
Searching...
No Matches
Public Member Functions | List of all members
wxGridEvent Class Reference
Class List by Category » Grid Related Classes | Class List by Category » Events

`#include </cygdrive/c/Users/Hamis/Cygwin-packaging/wxWidgets3.1/wxWidgets3.1-3.1.5-3.x86_64/src/wxWidgets-3.1.5/interface/wx/grid.h>`

Inheritance diagram for wxGridEvent:
[legend]

## Detailed Description

This event class contains information about various grid events.

Notice that all grid event table macros are available in two versions: `EVT_GRID_XXX` and `EVT_GRID_CMD_XXX`. The only difference between the two is that the former doesn't allow to specify the grid window identifier and so takes a single parameter, the event handler, but is not suitable if there is more than one grid control in the window where the event table is used (as it would catch the events from all the grids). The version with `CMD` takes the id as first argument and the event handler as the second one and so can be used with multiple grids as well. Otherwise there are no difference between the two and only the versions without the id are documented below for brevity.

## Events using this class

The following event handler macros redirect the events to member function handlers 'func' with prototypes like:

void handlerFuncName(wxGridEvent& event)

Event macros:

- EVT_GRID_CELL_CHANGING(func):
  The user is about to change the data in a cell. The new cell value as string is available from GetString() event object method. This event can be vetoed if the change is not allowed. Processes a `wxEVT_GRID_CELL_CHANGING` event type.
- EVT_GRID_CELL_CHANGED(func):
  The user changed the data in a cell. The old cell value as string is available from GetString() event object method. Notice that vetoing this event still works for backwards compatibility reasons but any new code should only veto EVT_GRID_CELL_CHANGING event and not this one. Processes a `wxEVT_GRID_CELL_CHANGED` event type.
- EVT_GRID_CELL_LEFT_CLICK(func):
  The user clicked a cell with the left mouse button. Processes a `wxEVT_GRID_CELL_LEFT_CLICK` event type.
- EVT_GRID_CELL_LEFT_DCLICK(func):
  The user double-clicked a cell with the left mouse button. Processes a `wxEVT_GRID_CELL_LEFT_DCLICK` event type.
- EVT_GRID_CELL_RIGHT_CLICK(func):
  The user clicked a cell with the right mouse button. Processes a `wxEVT_GRID_CELL_RIGHT_CLICK` event type.
- EVT_GRID_CELL_RIGHT_DCLICK(func):
  The user double-clicked a cell with the right mouse button. Processes a `wxEVT_GRID_CELL_RIGHT_DCLICK` event type.
- EVT_GRID_EDITOR_HIDDEN(func):
  The editor for a cell was hidden. Processes a `wxEVT_GRID_EDITOR_HIDDEN` event type.
- EVT_GRID_EDITOR_SHOWN(func):
  The editor for a cell was shown. Processes a `wxEVT_GRID_EDITOR_SHOWN` event type.
- EVT_GRID_LABEL_LEFT_CLICK(func):
  The user clicked a label with the left mouse button. Processes a `wxEVT_GRID_LABEL_LEFT_CLICK` event type.
- EVT_GRID_LABEL_LEFT_DCLICK(func):
  The user double-clicked a label with the left mouse button. Processes a `wxEVT_GRID_LABEL_LEFT_DCLICK` event type.
- EVT_GRID_LABEL_RIGHT_CLICK(func):
  The user clicked a label with the right mouse button. Processes a `wxEVT_GRID_LABEL_RIGHT_CLICK` event type.
- EVT_GRID_LABEL_RIGHT_DCLICK(func):
  The user double-clicked a label with the right mouse button. Processes a `wxEVT_GRID_LABEL_RIGHT_DCLICK` event type.
- EVT_GRID_SELECT_CELL(func):
  The given cell was made current, either by user or by the program via a call to SetGridCursor() or GoToCell(). Processes a `wxEVT_GRID_SELECT_CELL` event type.
- EVT_GRID_COL_MOVE(func):
  The user tries to change the order of the columns in the grid by dragging the column specified by GetCol(). This event can be vetoed to either prevent the user from reordering the column change completely (but notice that if you don't want to allow it at all, you simply shouldn't call wxGrid::EnableDragColMove() in the first place), vetoed but handled in some way in the handler, e.g. by really moving the column to the new position at the associated table level, or allowed to proceed in which case wxGrid::SetColPos() is used to reorder the columns display order without affecting the use of the column indices otherwise. This event macro corresponds to `wxEVT_GRID_COL_MOVE` event type.
- EVT_GRID_COL_SORT(func):
  This event is generated when a column is clicked by the user and its name is explained by the fact that the custom reaction to a click on a column is to sort the grid contents by this column. However the grid itself has no special support for sorting and it's up to the handler of this event to update the associated table. But if the event is handled (and not vetoed) the grid supposes that the table was indeed resorted and updates the column to indicate the new sort order and refreshes itself. This event macro corresponds to `wxEVT_GRID_COL_SORT` event type.
- EVT_GRID_TABBING(func):
  This event is generated when the user presses TAB or Shift-TAB in the grid. It can be used to customize the simple default TAB handling logic, e.g. to go to the next non-empty cell instead of just the next cell. See also wxGrid::SetTabBehaviour(). This event is new since wxWidgets 2.9.5.

  ##

Library: wxCore

<>< =''>:</>&;&;< =''>\ , \ </></>

## Public Member Functions
| wxGridEvent ()
| Default constructor.
| wxGridEvent (int id, wxEventType type, wxObject *obj, int row=-1, int col=-1, int x=-1, int y=-1, bool sel=true, const wxKeyboardState &kbd=wxKeyboardState())
| Constructor for initializing all event attributes.
bool | AltDown () const
| Returns true if the Alt key was down at the time of the event.
bool | ControlDown () const
| Returns true if the Control key was down at the time of the event.
int | GetCol () const
| Column at which the event occurred.
wxPoint | GetPosition () const
| Position in pixels at which the event occurred.
int | GetRow () const
| Row at which the event occurred.
bool | MetaDown () const
| Returns true if the Meta key was down at the time of the event.
bool | Selecting () const
| Returns true if the user is selecting grid cells, or false if deselecting.
bool | ShiftDown () const
| Returns true if the Shift key was down at the time of the event.
Public Member Functions inherited from wxNotifyEvent
| wxNotifyEvent (wxEventType eventType=wxEVT_NULL, int id=0)
| Constructor (used internally by wxWidgets only).
void | Allow ()
| This is the opposite of Veto(): it explicitly allows the event to be processed.
bool | IsAllowed () const
| Returns true if the change is allowed (Veto() hasn't been called) or false otherwise (if it was).
void | Veto ()
| Prevents the change announced by this event from happening.
Public Member Functions inherited from wxCommandEvent
| wxCommandEvent (wxEventType commandEventType=wxEVT_NULL, int id=0)
| Constructor.
void * | GetClientData () const
| Returns client data pointer for a listbox or choice selection event (not valid for a deselection).
wxClientData * | GetClientObject () const
| Returns client object pointer for a listbox or choice selection event (not valid for a deselection).
long | GetExtraLong () const
| Returns extra information dependent on the event objects type.
int | GetInt () const
| Returns the integer identifier corresponding to a listbox, choice or radiobox selection (only if the event was a selection, not a deselection), or a boolean value representing the value of a checkbox.
int | GetSelection () const
| Returns item index for a listbox or choice selection event (not valid for a deselection).
wxString | GetString () const
| Returns item string for a listbox or choice selection event.
bool | IsChecked () const
| This method can be used with checkbox and menu events: for the checkboxes, the method returns true for a selection event and false for a deselection one.
bool | IsSelection () const
| For a listbox or similar event, returns true if it is a selection, false if it is a deselection.
void | SetClientData (void *clientData)
| Sets the client data for this event.
void | SetClientObject (wxClientData *clientObject)
| Sets the client object for this event.
void | SetExtraLong (long extraLong)
| Sets the m_extraLong member.
void | SetInt (int intCommand)
| Sets the m_commandInt member.
void | SetString (const wxString &string)
| Sets the m_commandString member.
Public Member Functions inherited from wxEvent
| wxEvent (int id=0, wxEventType eventType=wxEVT_NULL)
| Constructor.
virtual wxEvent * | Clone () const =0
| Returns a copy of the event.
wxObject * | GetEventObject () const
| Returns the object (usually a window) associated with the event, if any.
wxEventType | GetEventType () const
| Returns the identifier of the given event type, such as `wxEVT_BUTTON`.
virtual wxEventCategory | GetEventCategory () const
| Returns a generic category for this event.
int | GetId () const
| Returns the identifier associated with this event, such as a button command id.
wxObject * | GetEventUserData () const
| Return the user data associated with a dynamically connected event handler.
bool | GetSkipped () const
| Returns true if the event handler should be skipped, false otherwise.
long | GetTimestamp () const
| Gets the timestamp for the event.
bool | IsCommandEvent () const
| Returns true if the event is or is derived from wxCommandEvent else it returns false.
void | ResumePropagation (int propagationLevel)
| Sets the propagation level to the given value (for example returned from an earlier call to wxEvent::StopPropagation).
void | SetEventObject (wxObject *object)
| Sets the originating object.
void | SetEventType (wxEventType type)
| Sets the event type.
void | SetId (int id)
| Sets the identifier associated with this event, such as a button command id.
void | SetTimestamp (long timeStamp=0)
| Sets the timestamp for the event.
bool | ShouldPropagate () const
| Test if this event should be propagated or not, i.e. if the propagation level is currently greater than 0.
void | Skip (bool skip=true)
| This method can be used inside an event handler to control whether further event handlers bound to this event will be called after the current one returns.
int | StopPropagation ()
| Stop the event from propagating to its parent window.
Public Member Functions inherited from wxObject
| wxObject ()
| Default ctor; initializes to NULL the internal reference data.
| wxObject (const wxObject &other)
| Copy ctor.
virtual | ~wxObject ()
| Destructor.
virtual wxClassInfo * | GetClassInfo () const
| This virtual function is redefined for every class that requires run-time type information, when using the wxDECLARE_CLASS macro (or similar).
wxObjectRefData * | GetRefData () const
| Returns the wxObject::m_refData pointer, i.e. the data referenced by this object.
bool | IsKindOf (const wxClassInfo *info) const
| Determines whether this class is a subclass of (or the same class as) the given class.
bool | IsSameAs (const wxObject &obj) const
| Returns true if this object has the same data pointer as obj.
void | Ref (const wxObject &clone)
| Makes this object refer to the data in clone.
void | SetRefData (wxObjectRefData *data)
| Sets the wxObject::m_refData pointer.
void | UnRef ()
| Decrements the reference count in the associated data, and if it is zero, deletes the data.
void | UnShare ()
| This is the same of AllocExclusive() but this method is public.
void | operator delete (void *buf)
| The delete operator is defined for debugging versions of the library only, when the identifier `__WXDEBUG__` is defined.
void * | operator new (size_t size, const wxString &filename=NULL, int lineNum=0)
| The new operator is defined for debugging versions of the library only, when the identifier `__WXDEBUG__` is defined.

## Additional Inherited Members
Protected Member Functions inherited from wxObject
void | AllocExclusive ()
| Ensure that this object's data is not shared with any other object.
virtual wxObjectRefData * | CreateRefData () const
| Creates a new instance of the wxObjectRefData-derived class specific to this object and returns it.
virtual wxObjectRefData * | CloneRefData (const wxObjectRefData *data) const
| Creates a new instance of the wxObjectRefData-derived class specific to this object and initializes it copying data.
Protected Attributes inherited from wxEvent
int | m_propagationLevel
| Indicates how many levels the event can propagate.
Protected Attributes inherited from wxObject
wxObjectRefData * | m_refData
| Pointer to an object which is the object's reference-counted data.

## Constructor & Destructor Documentation

## ◆ wxGridEvent() [1/2]

wxGridEvent::wxGridEvent | ( |  | ) |

Default constructor.

## ◆ wxGridEvent() [2/2]

wxGridEvent::wxGridEvent | ( | int | id,
|  | wxEventType | type,
|  | wxObject * | obj,
|  | int | row = -1,
|  | int | col = -1,
|  | int | x = -1,
|  | int | y = -1,
|  | bool | sel = true,
|  | const wxKeyboardState & | kbd = wxKeyboardState() )

Constructor for initializing all event attributes.

## Member Function Documentation

## ◆ AltDown()

bool wxGridEvent::AltDown | ( |  | ) | const

Returns true if the Alt key was down at the time of the event.

## ◆ ControlDown()

bool wxGridEvent::ControlDown | ( |  | ) | const

Returns true if the Control key was down at the time of the event.

## ◆ GetCol()

int wxGridEvent::GetCol | ( |  | ) | const

Column at which the event occurred.

Notice that for a `wxEVT_GRID_SELECT_CELL` event this column is the column of the newly selected cell while the previously selected cell can be retrieved using wxGrid::GetGridCursorCol().

## ◆ GetPosition()

wxPoint wxGridEvent::GetPosition | ( |  | ) | const

Position in pixels at which the event occurred.

## ◆ GetRow()

int wxGridEvent::GetRow | ( |  | ) | const

Row at which the event occurred.

Notice that for a `wxEVT_GRID_SELECT_CELL` event this row is the row of the newly selected cell while the previously selected cell can be retrieved using wxGrid::GetGridCursorRow().

## ◆ MetaDown()

bool wxGridEvent::MetaDown | ( |  | ) | const

Returns true if the Meta key was down at the time of the event.

## ◆ Selecting()

bool wxGridEvent::Selecting | ( |  | ) | const

Returns true if the user is selecting grid cells, or false if deselecting.

## ◆ ShiftDown()

bool wxGridEvent::ShiftDown | ( |  | ) | const

Returns true if the Shift key was down at the time of the event.